import 'package:flutter/material.dart';

import 'package:shareinstall_flutter/shareinstall_flutter.dart';

void main() => runApp(MyApp());

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  var wakeupData = '';
  var installData = '';

  @override
  void initState() {
    super.initState();
    ShareinstallFlutter.addEventHandler((data) {
      //app后台唤醒到前台 data为json字符串
      print("data wakeup newIntent>>>" + data);
      setState(() {
        wakeupData = 'data wakeup newIntent>>>$data';
      });
    });
    ShareinstallFlutter.getInstall().then((data) {
      //获取安装参数 data为json字符串
      print("data install>>>" + data);
      setState(() {
        installData = 'data install>>>$data';
      });
    });
    ShareinstallFlutter.getWakeUp().then((data) {
      //获取唤醒参数 data为json字符串
      print("data wakeup>>>" + data);
      setState(() {
        wakeupData = 'data wakeup>>>$data';
      });
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('shareintsall Plugin example app'),
        ),
        body: Center(
          child: Column(
            children: [
              Text('唤醒参数：$wakeupData'),
              Text('安装参数：$installData'),
              MaterialButton(
                child: Text(
                  '注册上报',
                  textAlign: TextAlign.center,
                  style: TextStyle(fontSize: 18, color: Colors.blueAccent),
                ),
                onPressed: () {
                  ShareinstallFlutter.reportRegister().then((data) {
                    //注册统计上报  App注册以后可调用此方法 在shareinstall后台可看到注册量统计
                    print("data reportRegister>>>" + data);
                  });
                },
              ),
              MaterialButton(
                child: Text(
                  '清除自定义参数',
                  textAlign: TextAlign.center,
                  style: TextStyle(fontSize: 18, color: Colors.blueAccent),
                ),
                onPressed: () {
                  ShareinstallFlutter.delCustomParams().then((data) {
                    print("data delCustomParams>>>" + data);
                  });
                },
              )
            ],
          ),
        ),
      ),
    );
  }
}
