

#import "ShareinstallFlutterPlugin.h"
//#import "ShareInstallSDK.h"
//#import <ShareInstallSDK.h>
#import <ShareInstallSDK/ShareInstallSDK.h>
@interface ShareinstallFlutterPlugin()<ShareInstallDelegate> {
    FlutterMethodChannel* _methodChannel;
    NSString *wakeUpJson;
    BOOL isRegister;
}
@end
@implementation ShareinstallFlutterPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"shareinstall_flutter"
            binaryMessenger:[registrar messenger]];
  ShareinstallFlutterPlugin* instance = [[ShareinstallFlutterPlugin alloc] initWithChannel:channel];
  [registrar addMethodCallDelegate:instance channel:channel];
    [registrar addApplicationDelegate:instance];
}

- (instancetype)initWithChannel:(FlutterMethodChannel*)channel{
    self = [super init];
    if(self){
        NSAssert(self, @"super init cannot be nil");
        _methodChannel=channel;
    }
    return self;
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    if([@"getInstall" isEqualToString:call.method]){
        [[ShareInstallSDK getInitializeInstance] getInstallCallBackBlock:^(NSString *jsonStr) {
            result(jsonStr);
        }];
    } else if([@"getWakeUp" isEqualToString:call.method]){
        isRegister = YES;
        if (wakeUpJson.length != 0) {
            [_methodChannel invokeMethod:@"wakeup" arguments:wakeUpJson];
            wakeUpJson = nil;
        }else {
            result(nil);
        }
    } else if([@"reportRegister" isEqualToString:call.method]){
        [ShareInstallSDK reportRegister];
    } else if([@"clearAppGetInfoListener" isEqualToString:call.method]){
        result(nil);
    } else if([@"delCustomParams" isEqualToString:call.method]){
        [ShareInstallSDK delCustomParams:^(NSString *str) {
            result(str?:@"");
        }];
    } else {
        result(FlutterMethodNotImplemented);
    }
}

- (void)getWakeUpParamsFromSmartInstall: (id) params withError: (NSError *) error{
   
    NSString *wakeUpDicResult = @"";
    if ([params isKindOfClass:[NSString class]]) {
        wakeUpDicResult = params;
    }
    if ([params isKindOfClass:[NSDictionary class]]) {
        wakeUpDicResult = [self convertToJsonData:params];
    }
    
    wakeUpJson = wakeUpDicResult;
    if (isRegister) {
        [_methodChannel invokeMethod:@"wakeup" arguments:wakeUpJson];
        wakeUpJson = nil;
    }
    else {
        wakeUpJson = wakeUpDicResult;
    }
}

-(NSString *)convertToJsonData:(NSDictionary *)dict{
    
    NSError *error;
    
    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dict options:NSJSONWritingPrettyPrinted error:&error];
    
    NSString *jsonString;
    
    {
        
        jsonString = [[NSString alloc]initWithData:jsonData encoding:NSUTF8StringEncoding];
        
    }
    
    NSMutableString *mutStr = [NSMutableString stringWithString:jsonString];
    
    NSRange range = {0,jsonString.length};
    
    //去掉字符串中的空格
    
    [mutStr replaceOccurrencesOfString:@" " withString:@"" options:NSLiteralSearch range:range];
    
    NSRange range2 = {0,mutStr.length};
    
    //去掉字符串中的换行符
    
    [mutStr replaceOccurrencesOfString:@"\n" withString:@"" options:NSLiteralSearch range:range2];
    
    return mutStr;
    
}

+(void)universalLinkHandler:(NSURL *)url{
    
    if (url) {
        if ([url isKindOfClass:[NSURL class]]) {
            NSUserActivity *activity = [[NSUserActivity alloc]initWithActivityType:NSUserActivityTypeBrowsingWeb];
            activity.webpageURL = url;
            [ShareInstallSDK continueUserActivity:activity];
        }
    }
    
}
+(void)schemeUrlHandler:(NSURL *)url{
    
    if (url) {
        if ([url isKindOfClass:[NSURL class]]) {
            [ShareInstallSDK handLinkURL:url];
        }
    }

}

- (BOOL)application:(UIApplication*)application didFinishLaunchingWithOptions:(NSDictionary*)launchOptions {
    [ShareInstallSDK initWithDelegate:self withOptions:launchOptions];
    return YES;
}
- (BOOL)application:(UIApplication *)application continueUserActivity:(NSUserActivity *)userActivity restorationHandler:(void (^)(NSArray * _Nullable))restorationHandler {
    [ShareinstallFlutterPlugin universalLinkHandler:userActivity.webpageURL];
    return YES;
}
-(BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation {
    [self application:application handleOpenURL:url];
    return YES;
}
- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(nonnull NSDictionary *)options {
    [ShareinstallFlutterPlugin schemeUrlHandler:url];
    return YES;
}

@end
