import 'dart:async';

import 'package:flutter/services.dart';

typedef void WakeUpMessageHandler(String data);

class ShareinstallFlutter {
  static const MethodChannel _channel =
      const MethodChannel('shareinstall_flutter');
  static WakeUpMessageHandler _onWakeUpMessage;

  static void addEventHandler(WakeUpMessageHandler onWakeUpMessage) {
    _onWakeUpMessage = onWakeUpMessage;
    _channel.setMethodCallHandler(_handleMethod);
  }

  static Future<void> _handleMethod(MethodCall call) async {
    switch (call.method) {
      case "wakeup":
        // print(call.arguments);
        _onWakeUpMessage(call.arguments);
        break;
    }
  }

  static Future<String> getWakeUp() async {
    final String result = await _channel.invokeMethod('getWakeUp');
    return result;
  }

  static Future<String> getInstall() async {
    final String result = await _channel.invokeMethod('getInstall');
    return result;
  }

  static Future<String> reportRegister() async {
    final String result = await _channel.invokeMethod('reportRegister');
    return result;
  }

  static Future<String> delCustomParams() async {
    final String result = await _channel.invokeMethod('delCustomParams');
    return result;
  }
}
